package com.sooka.sponest.middleground.monitoringEquipment.chenganshengbang.service.impl;

import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson.JSONObject;
import com.ruoyi.common.core.web.domain.AjaxResult;
import com.sooka.sponest.middleground.monitoringEquipment.chenganshengbang.service.WaterPressureService;
import com.sooka.sponest.middleground.remoteapi.service.center.iot.RemoteIotService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

@Service
public class WaterPressureServiceImpl implements WaterPressureService {

    private static final Logger log = LoggerFactory.getLogger(WaterPressureServiceImpl.class);

    @Resource
    public RemoteIotService remoteIotService;

    /**水压传感器指令地址**/
    @Value("${monitoringEquipment.waterPressure.commandURL:}")
    public String commandURL;


    public void waterPressureMessageReceiver(String data){
        log.info("WaterPressure 接到数据 ==>{}",data);
        JSONObject object;
        AjaxResult res;
        try {
            object = JSONObject.parseObject(data);
            res = remoteIotService.saveWaterPressureDeviceData(object);
            log.info("WaterPressure 数据推送成功! data ===> {} , result ===> {}",data, res);
        }catch(Exception e){
            e.printStackTrace();
            log.error("WaterPressure 数据推送失败! data ===> {} , result ===> {}",data, e.getMessage());
        }
    }

    public String command(String data){
        log.info("WaterPressure-command 接到指令 ==>{}",data);
        JSONObject object;
        String res = null;
        try {
            object = JSONObject.parseObject(data);
            res = HttpRequest.post(commandURL)
                    .header("Content-Type", "application/json")
                    .body(object.toJSONString())
                    .execute().body();
            log.info("指令下发成功! data ===> {} , result ===> {}",data, res);
            return res;
        }catch(Exception e){
            e.printStackTrace();
            log.error("指令下发失败! data ===> {} , result ===> {}",data, e.getMessage());
            return res;
        }
    }
}
