package com.sooka.sponest.middleground.remoteapi.fallback.center.gpsTank;

import com.alibaba.fastjson.JSONObject;
import com.ruoyi.common.core.web.domain.AjaxResult;
import com.ruoyi.system.api.factory.RemoteUserFallbackFactory;
import com.sooka.sponest.middleground.remoteapi.service.center.gpsTank.RemoteGpsTankService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.cloud.openfeign.FallbackFactory;
import org.springframework.stereotype.Component;

/**
 * @program: ruoyi
 * @description: yy
 * @author: yy
 * @create: 2022-06-16 11:05
 **/
@Component
public class RemoteGpsTankBaseServiceFallbackFactory implements FallbackFactory<RemoteGpsTankService> {

    private static final Logger log = LoggerFactory.getLogger(RemoteUserFallbackFactory.class);

    @Override
    public RemoteGpsTankService create(Throwable cause) {
        log.error("北斗卫星定位设备车辆轨迹和行程任务任务模块-服务调用失败:{}", cause.getMessage());

        return new RemoteGpsTankService() {

            @Override
            public AjaxResult selectGasTankDevicesNewEndTime() {  return null; }

            @Override
            public AjaxResult remoteTrajectoryInsertBatch(JSONObject obj) {
                return null;
            }

            @Override
            public AjaxResult remoteMileageInsertBatch(JSONObject obj) {
                return null;
            }

            @Override
            public AjaxResult gpsTankInsertBatch(JSONObject obj) {
                return null;
            }

        };
    }
}
