package com.sooka.sponest.middleground.remoteapi.fallback.center.iot;

import com.alibaba.fastjson.JSONObject;
import com.ruoyi.common.core.domain.R;
import com.ruoyi.common.core.web.domain.AjaxResult;
import com.ruoyi.system.api.domain.SysFile;
import com.ruoyi.system.api.factory.RemoteUserFallbackFactory;
import com.sooka.sponest.middleground.remoteapi.service.center.iot.RemoteIotService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.cloud.openfeign.FallbackFactory;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.multipart.MultipartFile;

/**
 * @program: ruoyi
 * @description: yy
 * @author: yy
 * @create: 2022-06-16 11:05
 **/
@Component
public class RemoteIotBaseServiceFallbackFactory implements FallbackFactory<RemoteIotService> {

    private static final Logger log = LoggerFactory.getLogger(RemoteUserFallbackFactory.class);

    @Override
    public RemoteIotService create(Throwable cause) {
        log.error("IOT传感器设备任务-服务调用失败:{}", cause.getMessage());

        return new RemoteIotService() {


            @Override
            public AjaxResult saveWaterMonitoringData(@RequestBody JSONObject json) {
                return null;
            }

            @Override
            public AjaxResult saveWaterPressureDeviceData(@RequestBody JSONObject json){
                return null;
            }

            @Override
            public AjaxResult saveSennorDeviceData(@RequestBody JSONObject json){
                return null;
            }

            @Override
            public AjaxResult getDevideCodeMapByTypes(@RequestBody String types){
                return null;
            }

            @Override
            public AjaxResult saveInsectPestsDeviceData(@RequestBody JSONObject json){
                return null;
            }

            @Override
            public R<SysFile> upload(MultipartFile file){
                return null;
            }

            @Override
            public AjaxResult updateDeviceStatusQuartz() {
                return null;
            }



        };
    }
}
