package com.sooka.sponest.middleground.remoteapi.fallback.center.lineCharts;

import com.ruoyi.common.core.web.domain.AjaxResult;
import com.sooka.sponest.middleground.remoteapi.service.center.lineCharts.RemoteLineChartsService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.cloud.openfeign.FallbackFactory;
import org.springframework.stereotype.Component;

/**
 * @program: ruoyi
 * @description: yy
 * @author: yy
 * @create: 2022-06-16 11:05
 **/
@Component
public class RemoteLineChartsBaseServiceFallbackFactory implements FallbackFactory<RemoteLineChartsService> {

    private static final Logger log = LoggerFactory.getLogger(RemoteLineChartsService.class);

    @Override
    public RemoteLineChartsService create(Throwable cause) {
        log.error("监控中心首页折线图缓存任务模块-服务调用失败:{}", cause.getMessage());

        return new RemoteLineChartsService() {

            @Override
            public AjaxResult selectDayLineChartCountTask() {
                return null;
            }

            @Override
            public AjaxResult selectMonthlyLineChartCountTask() {
                return null;
            }

            @Override
            public AjaxResult quarterlineChartTask() {
                return null;
            }

            @Override
            public AjaxResult yearlineChartTask() {
                return null;
            }

        };
    }
}
