package com.sooka.sponest.middleground.remoteapi.fallback.center.system;

import com.ruoyi.common.core.domain.R;
import com.ruoyi.system.api.domain.SysUser;
import com.ruoyi.system.api.factory.RemoteUserFallbackFactory;
import com.sooka.sponest.middleground.remoteapi.service.center.system.RemoteSystemService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.cloud.openfeign.FallbackFactory;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @program: ruoyi
 * @description: yy
 * @author: yy
 * @create: 2022-06-16 11:05
 **/
@Component
public class RemoteSystemBaseServiceFallbackFactory implements FallbackFactory<RemoteSystemService> {

    private static final Logger log = LoggerFactory.getLogger(RemoteUserFallbackFactory.class);

    @Override
    public RemoteSystemService create(Throwable cause) {
        log.error("维护中心-服务调用失败:{}", cause.getMessage());

        return new RemoteSystemService() {

            @Override
            public R<List<SysUser>> userFeginlist(SysUser user) {
                return null;
            }

            @Override
            public R<String> selectConfigKey_insectPestsUrl() {
                return null;
            }

            @Override
            public R<String> selectConfigKey_fileUrl() {
                return null;
            }

            @Override
            public R<String> remotegetConfigKey(String configKey) {
                return null;
            }

        };
    }
}
