package com.sooka.sponest.middleground.remoteapi.service.center.dahuaLog;

import com.ruoyi.common.core.web.domain.AjaxResult;
import com.sooka.sponest.middleground.remoteapi.fallback.center.dahuaLog.RemoteDahuaLogBaseServiceFallbackFactory;
import com.sooka.sponest.middleground.remoteapi.service.ModulesServiceNameContants;
import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;

@FeignClient(
        contextId = "remoteDahuaLogService"
        , value = ModulesServiceNameContants.CENTER_MONITOR_DAHUALOG
        , fallbackFactory = RemoteDahuaLogBaseServiceFallbackFactory.class
        ,url = "${sooka.service.monitor-dahuaLog}"
)
public interface RemoteDahuaLogService {

    /**
     * 对接大华黑天云台日志定时任务
     */
    @ApiOperation(value = "对接大华黑天云台日志定时任务", notes = "对接大华黑天云台日志定时任务")
    @PostMapping("/dahuaBlackOperateLog/configureBlackTasks")
    public AjaxResult configureBlackTasks();

    /**
     * 对接大华白天云台日志定时任务
     */
    @ApiOperation(value = "对接大华白天云台日志定时任务", notes = "对接大华白天云台日志定时任务")
    @PostMapping("/dahuaWhiteOperateLog/configureWhiteTasks")
    public AjaxResult configureWhiteTasks();


}
