package com.sooka.sponest.middleground.remoteapi.service.center.gpsTank;

import com.alibaba.fastjson.JSONObject;
import com.ruoyi.common.core.web.domain.AjaxResult;
import com.sooka.sponest.middleground.remoteapi.fallback.center.gpsTank.RemoteGpsTankBaseServiceFallbackFactory;
import com.sooka.sponest.middleground.remoteapi.service.ModulesServiceNameContants;
import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

@FeignClient(
        contextId = "remoteGpsTankService"
        , value = ModulesServiceNameContants.CENTER_MONITOR_GPSTANK
        , fallbackFactory = RemoteGpsTankBaseServiceFallbackFactory.class
//        ,url = "${sooka.service.monitor-gpsTank}"
)
public interface RemoteGpsTankService {

    /**
     * 获取最新一次行动轨迹时间的设备id列表
     */
    @ApiOperation(value = "获取最新一次行动轨迹时间的设备id列表", notes = "获取最新一次行动轨迹时间的设备id列表")
    @GetMapping("/gps/devices/selectGasTankDevicesNewEndTime")
    public AjaxResult selectGasTankDevicesNewEndTime();

    /**
     * 新增北斗卫星定位车辆gps历史轨迹
     */
    @ApiOperation(value = "新增北斗卫星定位车辆gps历史轨迹", notes = "新增北斗卫星定位车辆gps历史轨迹")
    @PostMapping("/gps/trajectory/remoteInsertBatch")
    public AjaxResult remoteTrajectoryInsertBatch(@RequestBody JSONObject obj);

    /**
     * 新增北斗卫星定位车辆gps历史行程
     */
    @ApiOperation(value = "新增北斗卫星定位车辆gps历史行程", notes = "新增北斗卫星定位车辆gps历史行程")
    @PostMapping("/gps/mileage/remoteInsertBatch")
    public AjaxResult remoteMileageInsertBatch(@RequestBody JSONObject obj);

    /**
     * 新增煤气罐设备信息
     */
    @ApiOperation(value = "新增煤气罐设备信息", notes = "新增煤气罐设备信息")
    @PostMapping("/gps/devices/gpsTankInsertBatch")
    public AjaxResult gpsTankInsertBatch(@RequestBody JSONObject obj);


}
