package com.sooka.sponest.middleground.remoteapi.service.center.lineCharts;

import com.ruoyi.common.core.web.domain.AjaxResult;
import com.sooka.sponest.middleground.remoteapi.fallback.center.lineCharts.RemoteLineChartsBaseServiceFallbackFactory;
import com.sooka.sponest.middleground.remoteapi.service.ModulesServiceNameContants;
import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;

@FeignClient(
        contextId = "remoteLineCharService"
        , value = ModulesServiceNameContants.CENTER_MONITOR_LINECHARTS
        , fallbackFactory = RemoteLineChartsBaseServiceFallbackFactory.class
        ,url = "${sooka.service.monitor-lineCharts}"
)
public interface RemoteLineChartsService {

    /**
     * 监控中心首页-离线设备日折线图缓存
     */
    @ApiOperation(value = "监控中心首页-离线设备日折线图缓存", notes = "监控中心首页-离线设备日折线图缓存")
    @GetMapping("/camera/quartz/selectDayLineChartCountTask")
    public AjaxResult selectDayLineChartCountTask();

    /**
     * 监控中心首页-离线设备月折线图缓存
     */
    @ApiOperation(value = "监控中心首页-离线设备月折线图缓存", notes = "监控中心首页-离线设备月折线图缓存")
    @GetMapping("/camera/quartz/selectMonthlyLineChartCountTask")
    public AjaxResult selectMonthlyLineChartCountTask();

    /**
     * 监控中心首页-离线设备季度折线图缓存
     */
    @ApiOperation(value = "监控中心首页-离线设备季度折线图缓存", notes = "监控中心首页-离线设备季度折线图缓存")
    @GetMapping("/camera/quartz/quarterlineChartTask")
    public AjaxResult quarterlineChartTask();

    /**
     * 监控中心首页-离线设备年折线图缓存
     */
    @ApiOperation(value = "监控中心首页-离线设备年折线图缓存", notes = "监控中心首页-离线设备年折线图缓存")
    @GetMapping("/camera/quartz/yearlineChartTask")
    public AjaxResult yearlineChartTask();

}
