package com.sooka.sponest.middleground.remoteapi.service.center.system;

import com.ruoyi.common.core.domain.R;
import com.ruoyi.system.api.domain.SysUser;
import com.sooka.sponest.middleground.remoteapi.fallback.center.system.RemoteSystemBaseServiceFallbackFactory;
import com.sooka.sponest.middleground.remoteapi.service.ModulesServiceNameContants;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import java.util.List;

@FeignClient(contextId = "remoteSystemService", fallbackFactory = RemoteSystemBaseServiceFallbackFactory.class,value = ModulesServiceNameContants.SYSTEM_SERVICE)
public interface RemoteSystemService {
    /**
     * 获取系统用户
     *
     * @param user
     * @return com.ruoyi.common.core.domain.R<java.util.List < com.ruoyi.system.api.domain.SysUser>>
     * @author pengyu
     * @date 2023/3/8 16:27
     **/
    @PostMapping("/user/userFeginlist")
    public R<List<SysUser>> userFeginlist(@RequestBody SysUser user);

    /**
     * 获取系统参数配置
     *
     * @return com.ruoyi.common.core.domain.R<java.lang.String>
     * @author pengyu
     * @date 2023/3/8 16:27
     **/
    @GetMapping("/config/selectConfigKey/insectPestsUrl")
    public R<String> selectConfigKey_insectPestsUrl();

    @GetMapping("/config/selectConfigKey/fileUrl")
    public R<String> selectConfigKey_fileUrl();

    @PostMapping(value = "/config/remotegetConfigKey")
    R<String> remotegetConfigKey(@RequestBody String configKey);




}
